﻿;07-08-2022,17:44 fixed keys issue
;fix draw map
;colors 08-08-2022 done
;show code on click 08-08-2022 done
;09.08.2022 save file implemented
;10.08.2022 place highlight during drag'n'drop ,  check extension for savefile ,open file,C64 done,remember paths
;11.08.2022 - release, fixed reverse byte todo: join prepci(),drawchar(),drawmap() into single routine
;fix: CGA thin font, commandline current path processing

;20-08-2022 fixed loader
; copy data ok, context menu ok
;todo:Esc exits(done),up-down mirror(done),highlight range, context menu with operations(done)

;12-12-2022
;scrollarea- done(?)
; todo:drag'n'drop(done) ,save image(done) ,hexnumber(done)
;todo: cursor on map, display XY and char# - done(6:21,13-12-2022)
;15-12-2022 context menu for map ins/del char - done
;16-12-2022 todo: check ize of map while loading - done, ins/del row done
;17-23-2022 todo: grid on charmap - done, ins/del column done
;27-02-2023 add: Hex val in charmap
;26-05-2023 BUG: wrong save map routine
;30-05-2023 added alter hex number
;21-09-2023 incorrect size for C64 - must be 25 rows
;28-10-2023,10:12 start fixes 80x24,80x25
;28-10-2023,11:04 done character rotation
Global cc.a=0;current char
Global dc.a=0;drag char
Global *m=AllocateMemory(2048)
Global isdrag=0; flag of drag

Global cux.l=0;cursor X
Global cuy.l=0;cursor Y

Global v$="char8x8 v2 0.9d"

Global mw.l=1;map width
Global mh.l=1;map height
Global Dim ma(80,50);map w xh

Global cl0.l=0
Global cl1.l=$FFFFFF

Global ismapok.l ;flag window available
Global Dim rev(255);byte reverse

Global cp$=GetCurrentDirectory() ; current path

Global mapx=-1,mapy=-1

Global mapgridf=1

Global Dim ch1.a(8)

Enumeration ;gadgets
  #ca
  #cc ;canvas char
  #cm ;canvas map
  
  #ccdat;data for char
  
  #chra ; range
  #rab
  #rae
  #rabl
  #rael
  ;buttons scroll
  #bsl
  #bsr
  #bsu
  #bsd
  ;scrollarea
  #sa
EndEnumeration

Enumeration ; menu
  #file_open
  #file_quit
  
  #file_save96;ZX 96 chars,768bytes
  #file_save128;Atari 128 chars,1024bytes
  #file_save256;"IBM 256 chars,2048bytes
  #file_save_map
  #file_save_img
  
  #char_invert
  #char_revert
  #char_updown
  
  #char_clearcharset
  #char_clear
  
  #char_shift_left
  #char_shift_right
  #char_shift_up
  #char_shift_down
  
  #char_set_br
  #char_set_er
  
  #char_drag_swap
  #char_drag_copy
  
  #char_copyd
  
  #char_map_32x24
  #char_map_40x24
  #char_map_40x25
  #char_map_80x50
  #char_map_64x30
  #char_map_fillchar
  #char_map_grid
  #charset_cga
  #charset_c64;-
  #charset_atari
  #charset_866
  #charset_zx48
  #charset_zx80
  #charset_microsha
  #charset_juace
  #charset_hex
  
  #char_col1
  #char_col0
  #char_rotate_cw
  #char_rotate_aw
  ;menu #3
  #mapchar_insertchar
  #mapchar_deletechar
  #mapchar_insertrow
  #mapchar_deleterow
  #mapchar_insertcolumn
  #mapchar_deletecolumn
EndEnumeration

Procedure  drawmap()
  If ismapok
    If StartDrawing(CanvasOutput(#cm))
      Box(0,0,mw*16,mh*16,cl0)
      For y=0 To mh-1
        For x=0 To mw-1
          ch=ma(x,y)
          For yy=0 To 7
            b.a=128
            a.a=PeekA(*m+ch*8+yy)
            For xx=0 To 7
              If a&b
                Box(x*16+xx*2,y*16+yy*2,2,2,cl1)
              EndIf
              b>>1
            Next xx
          Next yy
        Next x
      Next y
      ;draw grid
      If mapgridf
      For y=0 To mh-1
        For x=0 To mw-1
          For k=0 To 15 Step 2
            Box(x*16+k,y*16,1,1,cl1)
            Box(x*16+k+1,y*16,1,1,cl0)
            Box(x*16,y*16+k,1,1,cl0)
            Box(x*16,y*16+k+1,1,1,cl1)

          Next k
      Next x
    Next y
    EndIf
      StopDrawing()
    Else  
      MessageRequester("ch8x8","draw char map error!")
    EndIf
  EndIf
EndProcedure

Procedure drawcur()
  For y=0 To 15
    For x=0 To 15
      ; Box(cux*16+x,cuy*16+y,1,1,Point(cux*16+x,cuy*16+y)|$FF0000)
      If (x!y)&1
        Box(cux*16+x,cuy*16+y,1,1,$7FFF00)
      EndIf
    Next x
  Next y
EndProcedure

Procedure prepci()
  If StartDrawing(ImageOutput(0))
    Box(0,0,256,256,cl0)
    For y=0 To 15
      For x=0 To 15
        For j=0 To 7
          b.l=128
          For i=0 To 7
            If PeekA(*m+(y*16+x)*8+j)&b
              Box(x*16+i*2,y*16+j*2,2,2,cl1)
            EndIf
            b>>1
          Next i
        Next j
      Next x
    Next y
    StopDrawing()
  Else
    MessageRequester("ch8x8","draw image char error!")
  EndIf
  If StartDrawing(CanvasOutput(#ca))
    DrawImage(ImageID(0),0,0)
    drawcur()
    StopDrawing()
  Else
    MessageRequester("ch8x8","draw cursor error!")
  EndIf
EndProcedure

Procedure drawchar()
  If StartDrawing(CanvasOutput(#cc))
    Box(0,0,128,128,cl0)
    cd$=""
    For y=0 To 7
      b.l=128
      a.l=PeekA(*m+cc*8+y)
      cd$=cd$+Str(a)+","
      For x=0 To 7
        If a&b
          Box(x*16,y*16,15,15,cl1)
        EndIf
        b>>1
      Next x
    Next y
    
    If Right(cd$,1)=","
      cd$=Mid(cd$,1,Len(cd$)-1)
    EndIf
    
    SetGadgetText(#ccdat,cd$)
    For x=0 To 7
      For y=0 To 127 Step 2
        Box(x*16,y,1,1,$FFFFFF)
        Box(x*16,y+1,1,1,0)
        Box(y,x*16,1,1,$FFFFFF)
        Box(y+1,x*16,1,1,0)
      Next y
    Next x
    StopDrawing()
    drawmap()
  Else
    MessageRequester("ch8x8","draw character error!")
  EndIf
EndProcedure 

Procedure movecursor(dx.l,dy.l)
  ;cux+dx
  cux=(cux+dx)&15
  ;cuy+dy
  cuy=(cuy+dy)&15
  cc=cux+16*cuy
  prepci()
  drawchar()
  c$=Str(cc)+"($"+RSet(Hex(cc),2,"0")+")"
  If cc>31
    c$=c$+"'"+Chr(cc)+"'"
  EndIf
  SetWindowTitle(0,v$+" "+c$)
EndProcedure 

Procedure createmnu()
  If CreateMenu(0, WindowID(0))
    MenuTitle("File")
    MenuItem(#file_open, "Open..."+Chr(9)+"Ctrl+O")
    OpenSubMenu("Save")
    MenuItem(#file_save96, "ZX 96 chars(768bytes)")
    MenuItem(#file_save128, "Atari 128 chars(1024bytes)")
    MenuItem(#file_save256, "IBM 256 chars(2048bytes)")
    MenuBar()
    MenuItem(#file_save_map, "Character_map")
    MenuItem(#file_save_img, "Characters image")
    CloseSubMenu()
    MenuItem(#file_quit, "Quit")
    
    MenuTitle("Char")
    OpenSubMenu("Map")
    MenuItem(#char_map_32x24, "ZX 32x24")
    MenuItem(#char_map_40x24, "Atari 40x24")
    MenuItem(#char_map_40x25, "C64 40x25")
    MenuItem(#char_map_80x50, "PC 80x50")
    MenuItem(#char_map_80x50, "USSR 64x30")
    MenuBar()
    MenuItem(#char_map_fillchar, "Fill map with current char")
    MenuItem(#char_map_grid, "Grid on map")
    CloseSubMenu()
    SetMenuItemState(0,#char_map_grid,1)
    
    OpenSubMenu("Charset")
    MenuItem(#charset_cga, "IBM PC CGA")
    MenuItem(#charset_866, "IBM PC 866")
    MenuBar()
    
    MenuItem(#charset_zx48, "ZX Spectrum")
    MenuItem(#charset_zx80, "ZX80")
    MenuItem(#charset_juace, "Jupiter Ace")
    MenuBar()
    MenuItem(#charset_c64, "C64 CAPS")
    MenuItem(#charset_atari, "Atari XL")
    MenuItem(#charset_microsha, "Microsha(USSR)")
    MenuBar()
    MenuItem(#charset_hex, "Hex numbers")
    
    CloseSubMenu()
    MenuBar()
    MenuItem(#char_drag_swap, "Drag mode:swap")
    MenuItem(#char_drag_copy, "Drag mode:copy")
    MenuBar()
    MenuItem(#char_rotate_cw, "rotate clockwise")
    MenuItem(#char_rotate_aw, "rotate anticlockwise")
    MenuBar()
    MenuItem(#char_col0, "Color for bit=0...")
    MenuItem(#char_col1, "Color for bit=1...")
    MenuBar()
    MenuItem(#char_clearcharset, "Erase all charset")
    MenuItem(#char_clear, "Clear character")
    MenuItem(#char_invert, "Invert"+Chr(9)+"Ctrl+I")
    MenuItem(#char_revert, "Revert char left-right")
    MenuItem(#char_updown, "Revert char up-down")
    MenuBar()
    MenuItem(#char_set_br, "Set begin range")
    MenuItem(#char_set_er, "Set end range")
    MenuItem(#char_copyd, "Copy data range to current")
    MenuBar()
    MenuItem(#char_shift_left, "Char shift left")
    MenuItem(#char_shift_right, "Char shift right")
    MenuItem(#char_shift_up, "Char shift up")
    MenuItem(#char_shift_down, "Char shift down")
    
    SetMenuItemState(0,#char_drag_swap,1)
    AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_I, #char_invert)
    AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_O, #file_open)
  Else
    MessageRequester("ch8x8","create menu error!")
  EndIf
  If CreatePopupMenu(2)
    MenuItem(#char_set_br, "Set begin range")
    MenuItem(#char_set_er, "Set end range")
    MenuItem(#char_copyd, "Copy data range to current")
  Else
    MessageRequester("ch8x8","create menu #2 error!")
  EndIf
  
  If CreatePopupMenu(3)
    MenuItem(#mapchar_insertchar, "Insert char")
    MenuItem(#mapchar_deletechar, "Delete char")
    MenuBar()
    MenuItem(#mapchar_insertrow, "Insert row")
    MenuItem(#mapchar_deleterow, "Delete row")
    MenuBar()
    MenuItem(#mapchar_insertcolumn, "Insert column")
    MenuItem(#mapchar_deletecolumn, "Delete column")
  Else
    MessageRequester("ch8x8","create menu #3 error!")
  EndIf
  
EndProcedure 


Procedure reswnd(mapw,maph)
  mw=mapw
  mh=maph
  SetGadgetAttribute(#sa,#PB_ScrollArea_InnerWidth,mapw*16)
  SetGadgetAttribute(#sa,#PB_ScrollArea_InnerHeight,maph*16)
  drawmap()
  HideWindow(1,0)
EndProcedure

Procedure.l min(a,b)
  If a<b
    ProcedureReturn a
  Else
    ProcedureReturn b
  EndIf
EndProcedure

Procedure.l max(a,b)
  If a>b
    ProcedureReturn a
  Else
    ProcedureReturn b
  EndIf
EndProcedure

Procedure drgui()
  prepci()
  drawchar()
EndProcedure

Procedure charop(chcode)
  If GetGadgetState(#chra)
    rngb=min(GetGadgetState(#rab),GetGadgetState(#rae))
    rnge=max(GetGadgetState(#rab),GetGadgetState(#rae))
  Else
    rngb=cc
    rnge=cc
  EndIf
  For i=rngb To rnge
    For j=0 To 7
      a.a=PeekA(*m+i*8+j)
      Select chcode
        Case 0: ;invert
          a=a!255
        Case 1: ;clear
          a=0
        Case 2: ;revert
          a=rev(a)
        Case 3: ;shift left
          a=(a<<1)|((a&128)/128)
        Case 4: ;shift right
          a=(a>>1)|((a&1)*128)
        Case 5: ;shift up
          a0.a=PeekA(*m+i*8)
          For k=0 To 6
            PokeA(*m+i*8+k,PeekA(*m+i*8+k+1))
          Next k
          PokeA(*m+i*8+7,a0)
          Break 1
        Case 6:;shift down
          a0=PeekA(*m+i*8+7)
          For k=7 To 1 Step -1
            PokeA(*m+i*8+k,PeekA(*m+i*8+k-1))
          Next k
          PokeA(*m+i*8,a0)
          Break 1
        Case 7 ; updown
          If j<4
            b=PeekA(*m+i*8+7-j)
            PokeA(*m+i*8+7-j,a)
            a=b
          EndIf
        Case 8 ; rotate cw
          For k=0 To 7
            ch1(7-k)=0
          For j=0 To 7
            If PeekA(*m+i*8+j)&1
              ch1(7-k)=ch1(7-k)|(1<<j)
            EndIf
            PokeA( *m+i*8+j,PeekA(*m+i*8+j)>>1 )
          Next j
          Next k
          For j=0 To 7
            PokeA( *m+i*8+j,ch1(j) )
          Next j
          Break 1

        Case 9 ; rotate acw
          For k=0 To 7
          For j=0 To 7
            ch1(k)=(ch1(k)<<1)|(PeekA(*m+i*8+j)&1)
            PokeA( *m+i*8+j,PeekA(*m+i*8+j)>>1 )
          Next j
          Next k
          For j=0 To 7
            PokeA( *m+i*8+j,ch1(j) )
          Next j
          Break 1
        Default:
          Debug "unkn:"+Str(chcode)
          Break 2
      EndSelect
      PokeA(*m+i*8+j,a)
    Next j
  Next i
  drgui()
  ;   prepci()
  ;   drawchar()
  ;   drawmap()
EndProcedure

Procedure updrange()
  r1.l=GetGadgetState(#rab)
  r$=Str(r1)
  If r1>=32
    r$=r$+":"+Chr(r1)
  EndIf
  SetGadgetText( #rabl,"BeginRange:"+r$ )
  
  r1.l=GetGadgetState(#rae)
  r$=Str(r1)
  If r1>=32
    r$=r$+":"+Chr(r1)
  EndIf
  SetGadgetText( #rael,"BeginRange:"+r$ )
  
EndProcedure

Procedure loadfile(f$)
  If Trim(f$)<>""
    fs=FileSize(f$)
    If fs>0
      If fs+cc*8>2048
        fs=8*(256-cc)
      Else
      EndIf
      If fs>0
        If ReadFile(0,f$)
          cp$=GetPathPart(f$)
          ReadData(0,*m+cc*8,fs)
          CloseFile(0)
        Else
          MessageRequester("Read error",f$)
        EndIf
      EndIf
    Else
      MessageRequester("No file",f$)
    EndIf
  EndIf
EndProcedure

Procedure loadmap(f$)
  If FileSize(f$)<=mw*mh
    If ReadFile(0,F$)
      For y=0 To mh-1
        For x=0 To mw-1
          If Not Eof(0)
            ma(x,y)=ReadAsciiCharacter(0)
          Else
            Break 2
          EndIf
        Next x
      Next y
      CloseFile(0)
      drawmap()
    Else
      MessageRequester("Open File", "unable to open:"+F$)
    EndIf
    
  Else
    MessageRequester("Open File", "to big map:"+F$)
  EndIf
  
EndProcedure

Procedure savefile(fs); filesize, -1 save map
  Pattern$ = "Font (*.fnt)|*.fnt"
  ext$=".fnt"
  If fs=-1
    Pattern$ = "Character map (*.map)|*.map"
    ext$=".map"
  EndIf
  
  If fs<>-1 And cc*8+fs>2048
    MessageRequester("Save File","out of size")
  Else
    File$ = SaveFileRequester("Please choose file to save", cp$, Pattern$, 0)
    If File$
      cp$=GetPathPart(File$)
      ;check extensions
      If LCase( Right( File$,4 ) )<>ext$
        File$+ext$
      EndIf
      If CreateFile(0,File$)
        If fs<>-1
          WriteData(0,*m+cc*8,fs)
        Else
          For y=0 To mh-1
            For x=0 To mw-1
              WriteAsciiCharacter(0,ma(x,y))
            Next x
          Next y
        EndIf;fs<>-1
        CloseFile(0)
      Else
        MessageRequester("Save file","File Error:"+File$)
      EndIf
    EndIf ;If File$
  EndIf
EndProcedure

If OpenWindow(0, 0, 0, 640, 480, v$, #PB_Window_SystemMenu | #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
  CanvasGadget(#ca, 0, 0, 260, 260,#PB_Canvas_Border|#PB_Canvas_Keyboard)
  TextGadget(#rabl,20,260,255,20,"Begin range:0",#PB_Text_Center)
  TrackBarGadget(#rab, 20, 280, 255, 30, 0, 255, #PB_TrackBar_Ticks)
  TextGadget(#rael,20,310,255,20,"End range:0",#PB_Text_Center)
  TrackBarGadget(#rae, 20, 330, 255, 30, 0, 255, #PB_TrackBar_Ticks)
  CheckBoxGadget(#chra,0,310,20,20,""):GadgetToolTip(#chra,"Enable range")
  
  FillMemory(*m,2048,0)
  
  If CountProgramParameters()=1
    loadfile(ProgramParameter(0))
  EndIf
  
  CreateImage(0,256,256)
  prepci()
  
  ;buttons
  ButtonGadget(#bsl,262,128,32,20,"<"):GadgetToolTip(#bsl,"shift left")
  ButtonGadget(#bsu,262+32,128,32,20,"^"):GadgetToolTip(#bsu,"shift up")
  ButtonGadget(#bsd,262+64,128,32,20,"v"):GadgetToolTip(#bsd,"shift down")
  ButtonGadget(#bsr,262+96,128,32,20,">"):GadgetToolTip(#bsr,"shift right")
  StringGadget(#ccdat,262,148,128,40,"",#ES_MULTILINE|#ESB_DISABLE_BOTH):GadgetToolTip(#ccdat,"Data for char")
  
  CanvasGadget(#cc, 262, 0, 128, 128)
  drawchar()
  createmnu()
  EnableGadgetDrop(#ca,#PB_Drop_Files,#PB_Drag_Copy)
  
  ;reverse char LUT
  For i=0 To 255
    ;    rev(i)=Val( "%"+ReverseString(RSet(Bin(i),9,"0")) )
    aa.a=i
    bb.a=0
    For j=0 To 7
      bb=(bb<<1)|(aa&1)
      aa>>1
    Next j
    rev(i)=bb
  Next i
  
  ;fill character map
  mw=40
  mh=24
  For y=0 To 50
    For x=0 To 80
      ma(x,y)=x+32;y+x
    Next x
  Next y
  
  dw=10
  If OpenWindow(1, WindowX(0)+40, WindowY(0)+40, 512+dw, 384+dw, "Character map", #PB_Window_SystemMenu | #PB_Window_MinimizeGadget|#PB_Window_Invisible)
    ;    ScrollAreaGadget(#sa, 0, 0, 512,384, 1280, 800, 16)
    ScrollAreaGadget(#sa, 0, 0, 512+dw,384+dw, 512+dw, 384+dw, 16)
    CanvasGadget(#cm,0,0,1280,800)
    ;CloseGadgetList()
    EnableGadgetDrop(#cm,#PB_Drop_Files,#PB_Drag_Copy)
    ismapok=1
  Else
    ismapok=0
    MessageRequester("Char8x8","Character Map not available")
  EndIf
  
  SetActiveGadget(#ca)
  ;---Event loop
  Repeat
    Event = WaitWindowEvent()
    If GetAsyncKeyState_(#VK_ESCAPE)&32768
      Break
    EndIf
    
    Select event
        ;--- drop font
      Case #PB_Event_GadgetDrop
        Files$ = EventDropFiles()
        If EventGadget()=#ca
          loadfile(Files$)
          drgui()
        ElseIf EventGadget()=#cm
          loadmap(Files$)
          drawmap()
        EndIf
        ;---menu       
      Case #PB_Event_Menu
        Select EventMenu()
;--colors for draw
          Case #char_col0
            sc=ColorRequester()
            If sc>-1
              cl0=sc
              drgui()
              drawmap()
            EndIf
          Case #char_col1
            sc=ColorRequester()
            If sc>-1
              cl1=sc
              drgui()
              drawmap()
            EndIf
;---map char menu items
          Case #mapchar_deletecolumn
            If mapx>=0 And mapy>=0
              For y=0 To mh-1
                For x=mapx To mw-1
                  ma(x,y)=ma(x+1,y)
                Next x
                ma(mw-1,y)=0
              Next y
              drawmap()
              mapx=-1
              mapy=-1
            EndIf
          Case #mapchar_insertcolumn
            If mapx>=0 And mapy>=0
              For y=0 To mh-1
                For x=mw-1 To mapx Step -1
                  ma(x+1,y)=ma(x,y)
                Next x
                ma(mapx,y)=0
              Next y
              drawmap()
              mapx=-1
              mapy=-1
            EndIf
          Case #mapchar_deleterow
            If mapx>=0 And mapy>=0
              ;If mapy<mh
              For y=mapy To mh-1
                For x=0 To mw
                  If y<mh-1
                    ma(x,y)=ma(x,y+1)
                  Else
                    ma(x,y)=0
                  EndIf
                Next x
              Next y
              drawmap()
              mapx=-1
              mapy=-1
            EndIf
          Case #mapchar_insertrow
            If mapx>=0 And mapy>=0
              For y=mh To mapy Step -1
                For x=0 To mw
                  If y<>mapy
                    ma(x,y)=ma(x,y-1)
                  Else
                    ma(x,y)=0
                  EndIf
                Next x
              Next y
              drawmap()
              mapx=-1
              mapy=-1
            EndIf
          Case #mapchar_deletechar
            If mapx>=0 And mapy>=0
              If mapx<mw
                For x=mapx To mw-1
                  ma(x,mapy)=ma(x+1,mapy)
                Next x
              EndIf
              ma(mw-1,mapy)=0
              drawmap()
              mapx=-1
              mapy=-1
            EndIf
          Case #mapchar_insertchar
            If mapx>=0 And mapy>=0
              If mapx<mw
                For xx=mw To mapx Step -1
                  ma(xx+1,y)=ma(xx,y)
                Next xx
              EndIf
              ma(mapx,mapy)=0
              drawmap()
              mapx=-1
              mapy=-1
            EndIf
          Case #char_copyd;---copy data range
            rngb=min(GetGadgetState(#rab),GetGadgetState(#rae))
            rnge=max(GetGadgetState(#rab),GetGadgetState(#rae))
            If cc>=rngb And cc<=rnge
              MessageRequester("Ch8x8","Range Error!")
            Else
              For i=rngb To rnge
                ;Debug i*8
                If (i+cc-rngb)*8>2047
                  Break
                EndIf
                For j=0 To 7
                  PokeA(*m+(cc+i-rngb)*8+j,PeekA(*m+i*8+j))
                Next j
              Next i
              drgui()
            EndIf
          Case #file_open
            ;---open file
            Pattern$ = "Font (*.fnt)|*.fnt|Character map (*.map)|*.map"
            File$ = OpenFileRequester("Please choose file to load", cp$, Pattern$,0)
            If File$
              cp$=GetPathPart(File$)
              Select SelectedFilePattern()
                Case 0:
                  loadfile(File$)
                Case 1:
                  loadmap(File$)
              EndSelect
            EndIf
          Case #file_save96
            savefile(768)
          Case #file_save128
            savefile(1024)
          Case #file_save256
            savefile(2048)
          Case #file_save_img
            File$ = SaveFileRequester("Please choose file to save", cp$, ".bmp", 0)
            ext$=".bmp"
            If File$
              cp$=GetPathPart(File$)
              ;check extensions
              If LCase( Right( File$,4 ) )<>ext$
                File$+ext$
              EndIf
              If SaveImage(0,File$)
              Else
                MessageRequester("Save file","File Error:"+File$)
              EndIf
            EndIf ;If File$          
          Case #file_save_map
            savefile(-1)
            ;---set ranges
          Case #char_set_br
            SetGadgetState(#rab,cc)
            updrange()
          Case #char_set_er
            SetGadgetState(#rae,cc)
            updrange()
            ;---char operations
          Case #char_invert
            charop(0)
          Case #char_clearcharset
            FillMemory(*m,2048,0)
            drgui()
          Case #char_clear
            charop(1)
          Case #char_revert
            charop(2)
          Case #char_shift_left
            charop(3)
          Case #char_shift_right
            charop(4)
          Case #char_shift_up
            charop(5)
          Case #char_shift_down
            charop(6)           
          Case #char_updown
            charop(7)
          Case #char_rotate_cw;---rotate character
            charop(8)
          Case #char_rotate_aw
            charop(9)

          Case #char_drag_swap
            SetMenuItemState(0,#char_drag_swap,1)
            SetMenuItemState(0,#char_drag_copy,0)
          Case #char_drag_copy
            SetMenuItemState(0,#char_drag_swap,0)
            SetMenuItemState(0,#char_drag_copy,1)
            ;---select charsets            
          Case #charset_microsha
            CopyMemory(?ussr,*m,1024)
            For i=0 To 1023
              PokeA(*m+1024+i,PeekA(*m+i)!255)
            Next i
            
            cl1=$FFFFFF;$7F7F7F
            cl0=0
            drgui()            
            
          Case #charset_hex
            cl1=$FFFFFF;$7F7F7F
            cl0=0
            For i=0 To 255
              a01=i>>4
              a02=i&15
;              PokeA(*m+i*8,0)
              For j=0 To 7
                a03=PeekA(?hexnum+a01*8+j)|(PeekA(?hexnum+a02*8+j)>>4)
                PokeA(*m+i*8+j,a03)
              Next j
;              PokeA(*m+i*8+7,0)
            Next i
            drgui()
          Case #charset_c64
            CopyMemory(?c64,*m,2048)
            cl1=RGB(112,109,235)
            cl0=RGB(46,44,155)
            drgui()
          Case #charset_866
            CopyMemory(?cp866,*m,2048)
            cl1=$FFFFFF
            cl0=0
            drgui()
          Case #charset_cga
            CopyMemory(?cga,*m,2048)
            cl1=$FFFFFF
            cl0=0
            drgui()
          Case #charset_atari
            CopyMemory(?a8,*m,1024)
            cl0=RGB(1,78,157)
            cl1=RGB(97,174,253)
            For i=0 To 1023
              PokeA(*m+1024+i,PeekA(*m+i)!255)
            Next i
            drgui()
          Case #charset_zx80
            CopyMemory(?zx80,*m,512)
            cl0=$FFFFFF
            cl1=0
            For i=0 To 511
              PokeA(*m+i+512,255!PeekA(*m+i))
            Next i
            drgui()
          Case #charset_juace
            cl0=0
            cl1=$FFFFFF
            CopyMemory(?juace,*m,1024)
            For i=0 To 1023
              PokeA(*m+1024+i,255!PeekA(*m+i))
            Next i
            drgui()
          Case #charset_zx48
            CopyMemory(?zx48,*m,1152)
            cl0=RGB(203,203,203);$8f8f8f
            cl1=0
            drgui()
          Case #file_quit:Break
          Case #char_map_32x24
            reswnd(32,24)
          Case #char_map_40x24
            reswnd(40,24)
          Case #char_map_40x25
            reswnd(40,25)
          Case #char_map_80x50
            reswnd(80,50)
          Case #char_map_64x30
            reswnd(64,30)
          Case #char_map_grid ;-- grid on charmap
            mapgridf=1-mapgridf
            SetMenuItemState(0,#char_map_grid,mapgridf)
            drawmap()
          Case #char_map_fillchar
            For y=0 To mh-1
              For x=0 To mw-1
                ma(x,y)=cc
              Next x
            Next y   
            drawmap()
        EndSelect
      Case  #PB_Event_CloseWindow
        Select EventWindow()
          Case 0: Break
          Case 1:HideWindow(1,1)
        EndSelect
      Case #PB_Event_Gadget
        ;--- gadget events
        Select EventGadget()
          Case #cm
            If EventType() = #PB_EventType_RightClick
              If IsMenu(3)
                mapx = Int(GetGadgetAttribute(#cm, #PB_Canvas_MouseX)/16)
                mapy = Int(GetGadgetAttribute(#cm, #PB_Canvas_MouseY)/16)
                DisplayPopupMenu(3, WindowID(1))
              EndIf
            EndIf
            
            If EventType() = #PB_EventType_MouseMove
              x = Int(GetGadgetAttribute(#cm, #PB_Canvas_MouseX)/16)
              y = Int(GetGadgetAttribute(#cm, #PB_Canvas_MouseY)/16)
              If ( (x>=0) And (x<=mw) ) And ( (y>=0) And y<=mh )
                drawmap()
                StartDrawing(CanvasOutput(#cm))
                DrawingMode(#PB_2DDrawing_Outlined)
                Box(x*16,y*16,16,16,255)
                StopDrawing()
                SetWindowTitle( 1,"Character map ("+Str(x)+","+Str(y)+"):"+Str(ma(x,y))+"["+RSet(Hex(ma(x,y)),2,"0")+"]" )
              EndIf
              
            EndIf
            If EventType() = #PB_EventType_LeftButtonDown Or (EventType() = #PB_EventType_MouseMove And GetGadgetAttribute(#cm, #PB_Canvas_Buttons) & #PB_Canvas_LeftButton)
              x = Int(GetGadgetAttribute(#cm, #PB_Canvas_MouseX)/16)
              y = Int(GetGadgetAttribute(#cm, #PB_Canvas_MouseY)/16)
              If ( (x>=0) And (x<=mw) ) And ( (y>=0) And y<=mh )
                ma(x,y)=cc
                drawmap()
              EndIf
            EndIf
          Case #bsl:charop(3)
          Case #bsr:charop(4)
          Case #bsu:charop(5)
          Case #bsd:charop(6)
          Case #rab
            updrange()
          Case #rae
            updrange()
          Case #cc
            x = GetGadgetAttribute(#cc, #PB_Canvas_MouseX)
            y = GetGadgetAttribute(#cc, #PB_Canvas_MouseY)
            If EventType() = #PB_EventType_LeftButtonDown Or (EventType() = #PB_EventType_MouseMove And GetGadgetAttribute(#cc, #PB_Canvas_Buttons) & #PB_Canvas_LeftButton)
              x=Int(x/16)
              y=Int(y/16)
              a.l=PeekA(*m+cc*8+y)
              If x<=7 And y<=7
                PokeA(*m+cc*8+y, a|(128>>x))
                drgui()
              EndIf
            ElseIf EventType() = #PB_EventType_RightButtonDown Or (EventType() = #PB_EventType_MouseMove And GetGadgetAttribute(#cc, #PB_Canvas_Buttons) & #PB_Canvas_RightButton)
              x=Int(x/16)
              y=Int(y/16)
              a.l=PeekA(*m+cc*8+y)
              If x<=7 And y<=7
                PokeA( *m+cc*8+y, a&(255!(128>>x)) )
                drgui()
              EndIf
            EndIf
          Case #ca
            x = GetGadgetAttribute(#ca, #PB_Canvas_MouseX)
            y = GetGadgetAttribute(#ca, #PB_Canvas_MouseY)
            If EventType() = #PB_EventType_RightClick;----right click context
              cuy=Int(y/16)
              cux=Int(x/16)
              cc=16*cuy+cux
              drawchar()
              movecursor(0,0)
              If IsMenu(2)
                DisplayPopupMenu(2, WindowID(0))
              EndIf
            EndIf
            If EventType() = #PB_EventType_KeyUp
              Select GetGadgetAttribute(#ca,#PB_Canvas_Key);0
                Case #PB_Shortcut_Up
                  ;If cuy
                    movecursor(0,-1)
                  ;EndIf
                Case #PB_Shortcut_Down
                  ;If cuy<>15
                    movecursor(0,1)
                  ;EndIf
                Case #PB_Shortcut_Left
                  ;If cux
                    movecursor(-1,0)
                  ;EndIf
                Case  #PB_Shortcut_Right
                  ;If cux<>15
                    movecursor(1,0)
                  ;EndIf
                Case  #PB_Shortcut_Insert
                  For i=2039 To cc*8 Step -1
                    PokeA( *m+i+8,PeekA(*m+i) )
                  Next i
                  For i=0 To 7
                    PokeA(*m+i+cc*8,0)
                  Next i
                  drgui()
                Case  #PB_Shortcut_Delete
                  If cc<255
                    CopyMemory(*m+cc*8+8,*m+cc*8,2048-(cc*8+8))
                  EndIf
                  For i=0 To 7
                    PokeA(*m+8*255+i,0)
                  Next i
                  drgui()
              EndSelect
            EndIf        
            If EventType() = #PB_EventType_MouseMove
              If isdrag=0
                StartDrawing(CanvasOutput(#ca))
                DrawImage(ImageID(0),0,0)
                drawcur()
                DrawingMode(#PB_2DDrawing_Outlined)
                Box( Int(x/16)*16,Int(y/16)*16,16,16,RGB(0,255,0) )
                StopDrawing()
              ElseIf isdrag=1
                GrabImage(0,1,(cd%16)*16,Int(cd/16)*16,16,16)
                StartDrawing(CanvasOutput(#ca))
                DrawImage(ImageID(0),0,0)
                drawcur()
                DrawImage(ImageID(1),x,y)
                DrawingMode(#PB_2DDrawing_Outlined)
                Box(Int(x/16)*16,Int(y/16)*16,16,16,255)
                StopDrawing()
                FreeImage(1)
              EndIf
            ElseIf EventType() = #PB_EventType_LeftClick
              cuy=Int(y/16)
              cux=Int(x/16)
              cc=16*cuy+cux
              drawchar()
              movecursor(0,0)
            ElseIf EventType() = #PB_EventType_LeftButtonDown
              If isdrag=0
                isdrag=1
                cd=16*Int(y/16)+Int(x/16)
                ;Debug "start drag:"+Str(cd)
              EndIf
            ElseIf EventType() = #PB_EventType_LeftButtonUp
              If isdrag=1
                isdrag=0
                yy=Int(y/16)
                xx=Int(x/16)
                dd=16*yy+xx
                If dd<>cd
                  dmode=GetMenuItemState(0,#char_drag_swap)
                  If ((xx>=0) And (xx<16)) And ((yy>=0) And (yy<16))
                    For i=0 To 7
                      a1.a=PeekA(*m+cd*8+i)
                      b1.a=PeekA(*m+dd*8+i)
                      If dmode
                        PokeA(*m+dd*8+i,a1)
                        PokeA(*m+cd*8+i,b1)
                      Else
                        PokeA(*m+dd*8+i,a1)
                      EndIf
                    Next i
                    drgui()
                  EndIf
                EndIf
              EndIf
            EndIf
        EndSelect
    EndSelect
  ForEver
EndIf

FreeMemory(*m)

DataSection
  a8:
  IncludeBinary "fonts\atari.fnt"
  zx48:
  IncludeBinary "fonts\zx8x8.fnt"
  zx80:
  IncludeBinary "fonts\zx80.fnt"
  cga:
  ;IncludeBinary "fonts\cga.002"
  IncludeBinary "fonts\Bm437 IBM CGAthin.bin"
  cp866:
  IncludeBinary "fonts\HUJ.fnt"
  juace:
  IncludeBinary "fonts\juace.fnt"
  ussr:
  IncludeBinary "fonts\microsha21.fnt"
  c64:
  IncludeBinary "fonts\c64.bin"
  hexnum:
IncludeBinary "binhex.bin"
; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 25
; Folding = ---
; EnableXP
; UseIcon = cubes.ico
; Executable = ch8x8v2_09d.exe
; Watchlist = drawmap()>ch;drawmap()>a;drawmap()>b